/*
	keithmoon.c - the name of this file and function have
	nothing to do with what it does, since no drums will be played
	and nobody will overdose on sleeping pills. But I need to name
	it something, right?
	
	Copyright 2000, Jeff Hunt (heinz@skylab.org)
	License is GPL
*/

#include <fcntl.h>
#include <sys/time.h>
#include <curses.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>
#include <math.h>

#include "curses.h"
#include "ctalk.h"
#include "functions.h"

void remove_beeps(char *string);

int num_occurences(char *str, int c) 
{
	int i = 0;
  
	while (*str) 
	{
		if (*str == c) 
		{
			i++;
		}
		str++;
	}
	return i;
}

void remove_beeps(char *string)
{
	int c_to_remove = '\a';
	char *place;
	char *copy;
	place = string;
	copy = string;
	while(*place) {
		if(*place != c_to_remove) {
			if (copy != place) {
				*copy = *place;
			}
			++copy;
		}
		++place;
	}
	*copy = '\0';
}
	
int keithmoon(int sockfd)
{
	fd_set rset;
	struct timeval timeout;
	int result;
	int curpos;
	char recvline[MAXLINE], outline[MAXLINE], buffer[MAXLINE];
	char inchar;
	int i;
	
	FILE *logf;

	/* Thank you, Michael Plump! */
	curpos = 0;

	wprintw(geektalk, "You are now logged on at %s\n", ourserver);

	touchwin(console);
	touchwin(geektalk);
	wrefresh(console);
	wrefresh(geektalk);

	nodelay(console, TRUE); 
	
	while(1)
	{
		FD_ZERO(&rset);
		FD_SET(sockfd, &rset);
		FD_SET(0, &rset);
		timeout.tv_sec = 0;
		timeout.tv_usec = 5;

		noecho();
		result = select(FD_SETSIZE, &rset, NULL, NULL, &timeout);
	
		if(FD_ISSET(sockfd, &rset))
		{
			if(readline(sockfd, recvline, MAXLINE) == 0)
			{
				close(sockfd);
				endwin();
				fprintf(stderr, "Connection closed by %s.\n", ourserver);
				fclose(logf);
				exit(4);
			}		

			if(num_occurences(recvline, '\a'))
			{
				remove_beeps(recvline);			
				flash();
				flash();
			}
			if(!num_occurences(recvline, '\n')) strcat(recvline, '\n');
			wprintw(geektalk, "%s", recvline);
			wrefresh(geektalk);
			touchwin(console);
			wrefresh(console);
		} else 
		if(FD_ISSET(0, &rset))
		{
			touchwin(console);
			inchar = wgetch(console);

			if(inchar && inchar != ERR)
			{
				if(inchar == '\n')
				{
					snprintf(outline, sizeof(outline), "%s\n", buffer);
					output(sockfd, outline);
					wclear(console);
					wrefresh(console);
					bzero(buffer, sizeof(buffer));
					bzero(outline, sizeof(outline));
					curpos = 0;
				} else
				if(inchar == 21)
				{
					curpos = 0;
					bzero(buffer, sizeof(buffer));
					wclear(console);
					wrefresh(console);
				} else
				if(inchar == 127)
				{
					if(curpos > 0)
					{
						curpos--;
						buffer[curpos] = '\0';
						wclear(console);
						wprintw(console, "%s", buffer);
						wrefresh(console);
					} else flash();
				} else
				{
					buffer[curpos] = inchar;
					curpos++;				
					wprintw(console, "%c", inchar);
					wrefresh(console);
					inchar = 0;
				}
			}
		} 
	}
}			
